; tresze5_asm

	in	win1_lib_hed1

	bra.s	start
	dc.l	0
	dc.w	$4afb
fname	dc.w	fname_e-fname-2
	dc.b	"tresze v1.05"
fname_e	ds.b	0
	ds.w	0

	in	win1_ass_pe_keys_pe
	in	win1_ass_pe_qdos_pt
	in	win1_ass_pe_keys_wwork
	in	win1_ass_pe_keys_wstatus
	in	win1_ass_pe_keys_wman
	in	win1_ass_pe_keys_wdef

	rsset	0
id	rs.l	1
wmvec	rs.l	1
slimit	rs.w	4
wkad	rs.l	1
strg	rs.w	3
wkad_hex	rs.b	8

*
start	lea	(a6,a4.l),a6	dataspace
	bsr	ope		open a con channel . .
	move.l	a0,id(a6) 	. . keep the ID
	move.w	#12,strg(a6)	total length of string
	move.l	#8,strg+2(a6)	no channels plus count of 8
	moveq	#iop_pinf,d0
	moveq	#-1,d3
	bsr	tp3
	move.l	a1,wmvec(a6)	keep WM vector . .
	beq	sui	---->	. . wasn't there!
	movea.l	a1,a2		set WM vector in A2
	lea	slimit(a6),a1
	moveq	#iop_flim,d0	maximum size of window . .
	bsr	tp3
	subi.l	#$C0008,(a1)	. . less 12, 8
	lea	wd0,a3		address of window definition
	move.l	#ww0_0,d1 	size of working definition . .
	bsr	getsp		. . sets ALCHP'd address to A0 . .
	movea.l	a0,a4		. . and to A4
	move.l	a0,wkad(a6)
	bsr	set_wkad
	lea	wst0,a1		Clear the status . .
	movea.l	a1,a0		. . area . .
	moveq	#66,d1		. . and 3 loose items
st1	clr.b	(a0)+
	dbf	d1,st1
	movea.l	id(a6),a0 	Replace the channel ID
	move.l	wd_xmin+wd_rbase(a3),d1     minimum size
	andi.l	#$FFF0FFF,d1	Lop off the scaling factors
	jsr	wm_setup(a2)	Set up the working definition
	moveq	#-1,d1		Set the window . .
	jsr	wm_prpos(a2)	. . where the pointer is
	jsr	wm_wdraw(a2)	Draw the contents
wrpt	jsr	wm_rptr(a2)	Read the pointer

	beq.s	no_err		Since D0 is zero D4 is non zero
	bra	sui	---->	D0 is non zero


*

con	dc.w	3
	dc.b	'con'

ope	lea	con,a0		To open "con" . .
	moveq	#-1,d1		. . for this job
	moveq	#0,d3
	moveq	#io_open,d0
	trap	#2
	rts

; We come here if we exit from wm_rptr without an error
; This means that D4 is non-zero which in turn means either that there
; was a window event (eg CTRL/F4) or that a loose item action routine
; has set a non-zero value in D4. If there was a window event (and no loose
; item) the appropriate bit will have been set in the event vector in the
; status area.

; If a loose item has a select key equal to that for an event, the event
; will not be detected by WM_RPTR since the loose item's action routine
; will have been called instead. The loose item's action routine can then
; set the event bit in the event vector and force an exit from WM_RPTR by
; setting the event number in D4. In that case the following code would be
; used. On the other hand the loose item's action routine could process the
; event internally without exiting from WM_RPTR.

no_err	movea.l	(a4),a1		status area
	btst	#pt__can,wsp_weve(a1)
	bne	sui		Exit

	btst	#pt__move,wsp_weve(a1)
	beq.s	wrpt
	bsr	move
	bra.s	wrpt


; Loose item action routines

; MOVE

afun0_0	bsr	move
af1	move.w	wwl_item(a3),d1	item number
	move.b	#wsi_mkav,ws_litem(a1,d1.w)	  ask for redraw
	moveq	#-1,d3		selective draw
	jsr	wm_ldraw(a2)
	clr.b	ws_litem(a1,d1.w)	available
	moveq	#0,d4
	moveq	#0,d0
	rts

; RESIZE

afun0_2	move.l	a3,-(a7)
	movea.l	ww_wdef(a4),a3	window definition
	bsr.s	resze
	movea.l	(a7)+,a3		restore pointer to loose item
	bra.s	af1

******************************************************************
*						     *
*  To perform the resize we need to			     *
*    a. Find the amount of resize (by wm_chwin)		     *
*    b. Throw away the current working definition (by wm_unset)  *
*    c. Find the new size (by wm_fsize) 		     *
*    d. Get space for the new working definition (by getsp)      *
*    e. Set up the new working definition  (by wm_setup)	     *
*    f. Position the new window  (by wm_prpos)		     *
*    g. Draw the contents  (by wm_wdraw)		     *
*						     *
* Comments					     *
*   On a. 					     *
*    We have to set the resize bit in the window byte of the     *
*    event vector in the status area before wm_chwin is called.  *
*    The change in size is returned in D1 and the window size    *
*    event number is returned in D4.			     *
*						     *
*   On c. 					     *
*    On entry to wm_fsize, D1 must contain the requested size.   *
*    This size must be chosen carefully. It must be no bigger    *
*    than the maximum in the window definition. It must be	     *
*    smaller than the maximum size for the window layout. The    *
*    x-size must be a multiple of 4 (to allow proper stippling.  *
*    Finally the size must not be bigger than the current screen *
*    size with allowance for shadow and border.		     *
*    On exit D1 contains the actual size and D2.W contains the   *
*    number of the repeated section.			     *
*    In this example we do not really need to use wm_fsize since *
*    we know that D2.W will be zero and that the value in D1     *
*    will be that on entry (since we have a variable window).    *
*						     *
*   On d. 					     *
*    The space needed is found from the label ww0_0 set in the   *
*    window definition.				     *
*						     *
*   On e. 					     *
*    For wm_setup we need on entry:			     *
*     D1 = size					     *
*     A0 = channel ID				     *
*     A1 -> status area				     *
*     A3 -> window definition 			     *
*     A4 -> space for working definition		     *
*						     *
*   On f. 					     *
*    On entry to wm_prpos we need the position in D1.	     *
*    In order to ensure that the bottom right corner of the      *
*    resized window is in the same position as that of the old   *
*    we need to subtract the increase in size from the pointer   *
*    origin in the old window.			     *
*    The new position is thus wd_org plus ww_xsize minus the     *
*    new size.					     *
*						     *
******************************************************************

resze	move.l	ww_xorg(a4),d7
	move.l	ww_wdef(a4),a5	window def
	add.l	wd_xorg(a5),d7	ptr position for PRPOS (optr)

	bsr	get_size		change is in D0
	tst.l	d1
	beq	sui	---->
	move.l	d0,d1

	move.w	wd_rbase+wd_xmin(a5),d5
	andi.w	#$fff,d5
	move.w	ww_xsize(a4),d4
	swap	d1
	add.w	d1,d4
	cmp.w	d5,d4
	bgt.s	resze1		d4 is greater
	move.w	d5,d4
resze1	move.w	wd_xsize(a5),d5
	cmp.w	d5,d4
	blt.s	resze2		d4 is smaller
	move.w	d5,d4
resze2	moveq	#3,d3
	add.w	d4,d3
	andi.w	#$fffc,d3 	keep answer in D3.W  (mv)
	move.w	wd_rbase+wd_ymin(a5),d5
	andi.w	#$fff,d5
	move.w	ww_ysize(a4),d4
	swap	d1
	add.w	d1,d4
	cmp.w	d5,d4
	bgt.s	resze3		d4 is greater
	move.w	d5,d4
resze3	move.w	wd_ysize(a5),d5
	cmp.w	d5,d4
	blt.s	resze4		d4 is smaller
	move.w	d5,d4
resze4	swap	d3
	move.w	d4,d3		D3 = new mv x | y
	jsr	wm_unset(a2)
	bsr	rechp

; Now restrict size to the screen size less (12,8)

	move.l	slimit(a6),d1
	cmp.w	d3,d1
	ble	resze7		d1 OK
	move.w	d3,d1
resze7	swap	d1
	swap	d3
	cmp.w	d3,d1
	ble	resze8		d1 OK
	move.w	d3,d1		new size
resze8	swap	d1		new limited size
	move.l	d1,d3
	jsr	wm_fsize(a2)
	move.l	d1,-(a7)		keep size pro tem
	move.l	#ww0_0,d1 	space needed
	bsr	getsp
	move.l	(a7)+,d1		replace size
	movea.l	a0,a4		new wwd
	cmp.l	wkad(a6),a4
	beq	resze9		no change
	move.l	a4,wkad(a6)	set new value . .
	bsr	set_wkad		. . of wkad
resze9	movea.l	id(a6),a0 	replace ID
	lea	wst0,a1		-> status area
	jsr	wm_setup(a2)
;
; The position for PRPOS is optr
;
	move.l	d7,d1
	jsr	wm_prpos(a2)
	jmp	wm_wdraw(a2)


get_size	lea	STRA0,a0		prog name
	lea	strg(a6),a1
	moveq	#32,d2		priority
	moveq	#-1,d1		I own the job
	moveq	#-1,d3		EW



lex	lib	win1_lib_lex2_bin

setwk_reg reg	d1-3/a2-3
set_wkad	movem.l	setwk_reg,-(sp)
	lea	wkad_hex,a0
	lea	wkad,a1
	movea.w	cn_itohl,a2
	jsr	(a2)
	movem.l	(sp)+,setwk_reg
	rts

; EXIT

afun0_1	moveq	#0,d0
	moveq	#pt__can,d4	ESC
	bset	#pt__can,wsp_weve(a1)
	rts

tp3	trap	#3
	tst.l	d0
	bne	sui	---->
	rts


	in	win1_ass_pe_treszew_asm

	in	win1_ass_pe_peas_sym_lst
	lib	win1_ass_pe_peas_bin


	in	win1_ass_pe_csprc_sym_lst
	lib	win1_ass_pe_csprc_bin


	in	win1_ass_pe_treszec_asm
